#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: formengine.tcl,v 1.11 2001/01/06 14:47:51 artur Exp $
#
# Information:
# Modul
# Implementierung von Check (Validating) GUI Klasse
# Editieren von Checks <Validatoren> fr FormEditor und SchemaEditor
# Ist kein InputWidget (Widget) hat aber 3 Funktionalitten
#  Initieren aut TDom sucht selbst die Tags
#  Update auf TDom (nur nach bedarf)

Class OValidatorSet -superclass OWidget -parameter {label}

OValidatorSet instproc map {twin} {
    [self] instvar win label
    frame $twin
    global lan
    ::label $twin.lab -text $label
    set widgetpar {{type OComboBox} {name type} 
	{valuelist {Regexpr Expr Length}} }
    keylset widgetpar label $lan(label.type)
    lappend widgetlist $widgetpar
    set widgetpar {{type OLabelEntry} {name value}
	{textwidth 20} }
    keylset widgetpar label $lan(label.value)
    lappend widgetlist $widgetpar
    set childframe [WidgetFactory make_inputs_keylist \
			[self]::wcontainer $widgetlist]
    OMultiFrame [self]::mframe -inputframe [self]::wcontainer -count 0
    [self]::mframe map $twin.mframe
    pack $twin.lab -anchor e
    pack $twin.mframe -expand yes -fill both
    set win $twin
    next
}
# Erwartet eine Parent Node die checks enthlt wenn keine dann leer
OValidatorSet instproc initFromTDom {dom_node} {
    set types {}
    set values {}
    foreach checks_node [$dom_node selectNodes child::checks] {
	foreach check_node [$checks_node selectNodes child::check] {
	    lappend types [$check_node getAttribute validator]
	    lappend values [$check_node text]
	}
	break
    }
    keylset datalist type $types
    keylset datalist value $values
    [self]::mframe set default $datalist
    [self]::mframe setdefault
}
OValidatorSet instproc initFromVariable {datalist} {
    [self]::mframe set default $datalist
    [self]::mframe setdefault
}
OValidatorSet instproc updateToTDom {dom_node} {
    if {[[self]::mframe count]==0} {
	tdom_deleteKontext $dom_node checks
	return
    }
    [self]::mframe updatevalue
    set value_kl [[self]::mframe getvalue]
    if {$value_kl!=[[self]::mframe default]} {
	set checks_node [tdom_clearKontext $dom_node checks]
	set types [keylget value_kl type]
	set values [keylget value_kl value]
	foreach type $types value $values {
	    set check_node [[$dom_node ownerDocument] createElement check]
	    $check_node setAttribute validator $type
	    $check_node appendChild [[$dom_node ownerDocument] createTextNode $value] 
	    $checks_node appendChild $check_node
	}
    }
}
OValidatorSet instproc getValue {} {
    [self]::mframe updatevalue
    return [[self]::mframe getvalue]
}
OValidatorSet proc tDomToVariable {dom_node} {
    set types {}
    set values {}
    foreach checks_node [$dom_node selectNodes child::checks] {
	foreach check_node [$checks_node selectNodes child::check] {
	    lappend types [$check_node getAttribute validator]
	    lappend values [$check_node text]
	}
	break
    }
    keylset datalist type $types
    keylset datalist value $values
    return $datalist
}
OValidatorSet proc variableToTDom {value_kl doc_node} {
    set types {}
    set values {}
    set types [keylget value_kl type]
    set values [keylget value_kl value]
    if {[llength $types]==0} { return {} }
    set checks_node [$doc_node createElement checks]
    foreach type $types value $values {
	set check_node [$doc_node createElement check]
	$check_node setAttribute validator $type
	$check_node appendChild [$doc_node createTextNode $value] 
	$checks_node appendChild $check_node
    }
    return $checks_node
}
